#include "global.h"

// Variveis globais descritivas do sistema
struct_sensors   sensors;                         // Sensores
struct_actuators actuators;                       // Actuadores

void initGlobal(void)
{
    initSensors();

    initActuators();
}

void initSensors(void)
{
    unsigned int i, j;

    // Estado do sistema
    sensors.sysStatus.reset=false;
    sensors.sysStatus.controlOn=false;
    sensors.sysStatus.deadlineError=false;

    // Inicializaos dos sensores dos servos
    for (i=0; i<N_SCU; ++i)
        for (j=0; j<N_SERVOS; ++j)  {
            sensors.servo[i][j].position=0;
            sensors.servo[i][j].velocity=0;
            sensors.servo[i][j].current =0;
        }

    // Inicializao dos sensores de fora dos ps
    for (i=0; i<N_FEET; ++i)
        for (j=0; j<N_FORCE_SENSORS; ++j)
            sensors.reaction[i][j]=0;

    // Inicializao dos sensores adicionais
    sensors.inclinometer[0]=sensors.inclinometer[1]=0; // Inclinmetro
    sensors.giroscope[0]=sensors.giroscope[1]=0;      // Giroscpio
}

void initActuators(void)
{
    unsigned int i, j;

    // Inicializaos dos actuadores
    for (i=0; i<N_SCU; ++i)
        for (j=0; j<N_SERVOS; ++j)  {
            actuators.servo[i][j].position=0;
            actuators.servo[i][j].velocity=0;
            actuators.servo[i][j].current =0;
        }
    // Controlador desligado!
    actuators.control.kp=actuators.control.kd=0;
}
