#include "global.h"

// Variveis globais descritivas do sistema
struct_sensors   sensors;                        // Sensores
struct_actuators actuators;                      // Actuadores

void initGlobal(void)
{
    initSensors();

    initActuators();
}

void initSensors(void)
{
    unsigned int j;

    // Estado do sistema
    sensors.sysStatus.reset=false;
    sensors.sysStatus.controlOn=false;
    sensors.sysStatus.deadlineError=false;

    // Inicializaos dos sensores dos servos
    for (j=0; j<N_SERVOS; ++j)  {
        sensors.servo[j].position=1;
        sensors.servo[j].velocity=2;
        sensors.servo[j].current =3;
    }

    // Inicializao dos sensores de fora do p (se existirem)
    for (j=0; j<N_FORCE_SENSORS; ++j)
        sensors.reaction[j]=4;

    // Inicializao dos sensores adicionais
    sensors.inclinometer[0]=sensors.inclinometer[1]=12; // Inclinmetro
    sensors.giroscope[0]=sensors.giroscope[1]=13;       // Giroscpio
}

void initActuators(void)
{
    unsigned int j;

    // Inicializaos dos actuadores
    for (j=0; j<N_SERVOS; ++j)  {
        actuators.servo[j].position=0;
        actuators.servo[j].velocity=0;
        actuators.servo[j].current =0;
    }

    // Controlador desligado!
    actuators.control.kp=actuators.control.kd=0;
}
