#include "servo.h"

struct_adcAnalog adcServo[N_SERVOS];
byte pwmServo[N_SERVOS];

byte ind=0;

//struct_servo servoSignal={0,0,0,0};
// float controlRequested=0.0;        // Dados do controlador

/*
void initController(signed int pos0)
{
    initPic();

    servo(pos0);

    controlRequested=(float) pos0;

	//Esperar 1 segundo
    wait(1000);
}

void controllerReady(void)
{
    timeTick=0;
}


unsigned char deadlineSucess(void)
{
    if (timeTick==1)    return DEADLINE_ERROR;

    return SUCESS;
}


#define KP  0.10  //0.17        // 0.10 ou 0.07 Para a gama -90 a 0 estes // 0.06 ou 0.06 -45=>+45 //  0.05    Destino: Binrio0
#define KD  0.45  //0.90        // 0.15    0.00 valores so os ideais     // 0.06    0.00          //  0.00

unsigned char controller(signed int posReference)
{
    signed int error, error_dif;
    static signed int error_prev=0;

    // Actualizao das medidas
    if (updateMeasures()==DEADLINE_ERROR)  return DEADLINE_ERROR;

    // Erro instantneo
   	error=posReference-servoSignal.positionFiltered;
    if (error>-3 && error<3)  error=0;

   	// Erro diferencial
    error_dif=error-error_prev;
   	// Actualizao do erro anterior
    error_prev=error;

   	// Aplicao do compensador
    controlRequested+=(float) error*KP + (float) error_dif*KD;

   	// Limitao do PWM a solicitar
    if ((signed int) controlRequested<-SERVO_RANGE)       controlRequested=(float) -SERVO_RANGE;
   	else if ((signed int) controlRequested>SERVO_RANGE)   controlRequested=(float)  SERVO_RANGE;

    // Aplicao da nova velocidade
    servo((signed int) controlRequested);

    if (timeTick==1)  return DEADLINE_ERROR;

    return SUCESS;
}
*/

#define PWM_STD	(unsigned char) (SERVO_RES/2)	// PWM standard

// Inicializao das estruturas de dados
//
void initServoData(void)
{
    byte srv;

    for (srv=0; srv<N_SERVOS; ++srv)  {
        pwmServo[srv]=PWM_STD;

        adcServo[srv].vpotMin=0;
        adcServo[srv].vpotImp=0;
    }
}

// Funcao para aquisicao do sinal presente no potencimetro do servo
//
#define SLOPE      180       // Com ganho 2... 884  // Declive*10 da funo Angulo=m*voltage+b
#define ORIGIN     236       //               235  // Ordenada na origem
#define POS(volt) (signed int) (ORIGIN - (signed int) ((unsigned int) (volt)*SLOPE/100));

// Funo bloqueante de processamento das medidas
//
void transferServoSensors(void)
{
    byte srv;
	signed int ang;

    for (srv=0; srv<N_SERVOS; ++srv)  {

        ang=POS(adcServo[srv].vpotMin);     // Clculo do ngulo associado  tenso medida
        if (ang<-127)     ang=-127;         // Truncagem do resultado de modo a caber numa varivel de 8 bits
        else if (ang>127) ang= 127;

        //ang=adcServo[srv].vpotMin;     // Clculo do ngulo associado  tenso medida

        sensors.servo[srv].position=ang;                    // Posio angular
        sensors.servo[srv].velocity=ind;                      // Velocidade
        sensors.servo[srv].current =adcServo[srv].vpotImp;  // Corrente
    }
}

// Device driver de definio da posio final do servo
//
#define PWM(ang)    (byte) (((word) SERVO_RANGE-(ang))*SERVO_RES/((word) 2*SERVO_RANGE))

void transferServoPWM(void)
{
    byte srv;
    signed char ang;

    for (srv=0; srv<N_SERVOS; ++srv)  {

        ang=actuators.servo[srv].position;
        if (ang<-SERVO_RANGE)       ang=-SERVO_RANGE;
        else if (ang>SERVO_RANGE)   ang= SERVO_RANGE;
	
	    pwmServo[srv]=PWM(ang);
    }
}
