#include "control.h"

// Segundo testes, o servo  capaz de percorrer 90 graus em 0.45 segundos (4graus/20ms)
#define POS_INICIAL  (-90)    // Posio inicial do servo
#define POS_FINAL    ( 70)    // Posio final
#define POS_STEP     (  3)    // Passo incremental

#define STEP_TIME      20     // Durao temporal de cada passo (ms)

void main(void)
{
    signed int pos=POS_INICIAL;
	unsigned char error[]="Violacao de deadline!";

    // Inicializao do controlador
    initController(POS_INICIAL);

    // Espera pelo caracter 'C'
    while (getChar()!='C');

    // Definio da durao de cada macrotick (para cada incremento de posio)
    setDelay(STEP_TIME);

	// Preparao do controlador
	controllerReady();	

    while (1) {

        // Aplicao de um pequeno degrau
//        servo(pos);

        // Enquanto o macrotick durar, executar repetitivamente
        // o bloco de cdigo interno:
        while (time.tickDelayed==0)  {

            if (!controller(pos))  break;
//            if (!updateMeasures())  break;

            // Enviar valor do potencimetro

	        sendValSign(pos,10);
		    sendChar(SEP);
	  		sendVal(servoSignal.potVoltage,10);
		    sendChar(SEP);
    		sendValSign(servoSignal.position,10);
		    sendChar(SEP);
			sendValSign((signed int) controlRequested,10);
		    sendChar(SEP);
    		sendVal(servoSignal.powerCurrent,10);
		    sendChar(EOF);

            // Neste ponto, ainda no se deve ter atingido a barreira dos 5 ms, por
            // isso, timeTick2 ainda deve ser nulo.
            // Caso no seja, houve violao da deadline!
            if (!deadlineSucess())  break;
        }
        time.tickDelayed=0;

        // Actualizao da posio
        if (POS_INICIAL<=POS_FINAL && pos<POS_FINAL)  		pos+=POS_STEP;
		else if (POS_INICIAL>POS_FINAL && pos>POS_FINAL)	pos-=POS_STEP;

        // Caso tenha ocorrido violao de deadline no bloco anterior, sair do
        // for actual...
        if (!deadlineSucess())  break;
    }

    // Se houve violao de deadline reiniciar o servo
	wait(20);
	sendChar(END);
    sendStr(error);
	sendChar(EOF);

    for(;;);
}
