//*******************************************************************************************
// SERVO.H
//
// Header file para incluir em programas que utilizem as funcoes definidas
// no ficheiro "servo.c"
//
// (c) Milton Ruas <a21824@alunos.det.ua.pt>
//     DETUA & DEMUA, Nov/2005
//*******************************************************************************************

#ifndef _PIC2_H
#define _PIC2_H

#include "servo.h"

#define TESTPIN 	PORTCbits.RC3	// Saida para teste do funcionamento do Timer2 (perodo de 5ms)
#define TESTPIN2    PORTCbits.RC2
#define TESTPIN3    PORTCbits.RC1

// Tick indicador da passagem dos 20ms
extern bool timeTick;

// ***************
// Device Drivers
// ***************

// Inicializacoes relativas ao microcontrolador
// pos0  a posio inicial do servo (entre -90 e +90 graus)
//
extern void initPic(void);

// *****************************
// Funes para gerar um atraso
// *****************************

// Funcao para gerar um atraso (ms)
//
extern void wait(unsigned int value);

#endif
