#include "global.h"

// Variveis globais descritivas do sistema

struct_sensors   sensors;                         // Sensores

#pragma udata bank1=0x100
struct_actuators actuators;                       // Actuadores
#pragma udata

void initGlobal(void)
{
    initSensors();

    initActuators();
}

void initSensors(void)
{
    unsigned int i, j;

    // Inicializaos dos sensores dos servos
    for (i=0; i<N_SCU; ++i)  {
        // Estado do sistema
        sensors.sysStatus[i]=0;

        for (j=0; j<N_SERVOS; ++j)  {
            sensors.servo[i][j].position=0;
            sensors.servo[i][j].velocity=0;
            sensors.servo[i][j].current =0;
        }
    }

    // Inicializao dos sensores de fora dos ps
    for (i=0; i<N_FEET; ++i)
        for (j=0; j<N_FORCE_SENSORS; ++j)
            sensors.reaction[i][j]=0;

    // Inicializao dos sensores adicionais
    sensors.inclinometer[0]=sensors.inclinometer[1]=0; // Inclinmetro
    sensors.giroscope[0]=sensors.giroscope[1]=0;      // Giroscpio
}

void initActuators(void)
{
    unsigned int i, j;

    // Inicializaos dos actuadores
    for (i=0; i<N_SCU; ++i)
        for (j=0; j<N_SERVOS; ++j)  {
            // Parmetros dos Controladores das juntas
            actuators.control[i][j].controlOn=false;
            actuators.control[i][j].ki=0;
            actuators.control[i][j].kp=0;
            actuators.control[i][j].kd=0;

            // Actuadores
            actuators.servo[i][j].position=0;
            actuators.servo[i][j].velocity=100;
            actuators.servo[i][j].current =0;
        }
}
