#include "global.h"

// Variveis globais descritivas do sistema
volatile struct_sensors   sensors;                        // Sensores
volatile struct_actuators actuators;                      // Actuadores

const signed char homePosition[N_SERVOS]=HOME_POSITIONS;


void initGlobal(void)
{
    initSensors();

    initActuators();
}

void initSensors(void)
{
    unsigned int j;

    // Estado do sistema
    sensors.sysStatus.reset=false;
    sensors.sysStatus.deadlineError=false;

    // Inicializaos dos sensores dos servos
    for (j=0; j<N_SERVOS; ++j)  {
        sensors.sysStatus.controlOn[j]=false;
        sensors.sysStatus.motionFin[j]=false;

        sensors.servo[j].position=0;
        sensors.servo[j].velocity=0;
        sensors.servo[j].current =0;
    }

    // Inicializao dos sensores de fora do p (se existirem)
    for (j=0; j<N_FORCE_SENSORS; ++j)
        sensors.reaction[j]=0;

    // Inicializao dos sensores adicionais
    sensors.inclinometer[0]=sensors.inclinometer[1]=0; // Inclinmetro
    sensors.giroscope[0]=sensors.giroscope[1]=0;       // Giroscpio
}

void initActuators(void)
{
    unsigned int j;

    // Inicializaos dos actuadores
    for (j=0; j<N_SERVOS; ++j)  {
        actuators.control[j].kp=0;
        actuators.control[j].kd=0;
        actuators.control[j].ki=0;
        actuators.control[j].controlOn=false;

        actuators.servo[j].position=homePosition[j];
        actuators.servo[j].velocity=100;
        actuators.servo[j].current =0;
    }
}

#pragma tmpdata isr_tmp

void reinitServo(byte srv)
{
    actuators.servo[srv].position=homePosition[srv];
}

#pragma tmpdata
