/*=======================================================================+
|             DEPARTAMENTO MECANICA UNIVERSIDADE AVEIRO                  |
|               Projecto Humanoide (PHUA - MODULROB)                     |
|                                                                        |
| Programadores:                                                         |
|              David Manuel Costa Gameiro          N:20281               |
|              Filipe Carvalho Mostardinha         N:22085               |
|                                                                        |
| Nome Ficheiro: MasterPrinc.c                                           |
|                                                                        |
|                            SOURCE FILE                                 |
+=======================================================================*/

#include "pic2.h"
#include "trajectory.h"

void main(void)
{
    // Inicializao das estruturas globais
    initGlobal();

    //inicializacao dos mdulos PIC2 e SERVO
    initPic();

    // Calibrao dos servos
    calibration();

    // Inicializao do Controlador PID
    initController();

    // Inicializao do gerador de trajectrias
    initTrajectory();

    for (;;)  {
        while (timeTick==0);
        timeTick=0;

        TESTPIN=1;
        
        // Aplicao de uma trajectria
        trajectory();

        // Actualizao dos actuadores
        controller();

        TESTPIN=0;

        // Verificao da ocorrncia de violao de Deadline
        if (timeTick)  sensors.sysStatus.deadlineError=true;
    }
}
