/*=======================================================================+
|             DEPARTAMENTO MECANICA UNIVERSIDADE AVEIRO                  |
|               Projecto Humanoide (PHUA - MODULROB)                     |
|                                                                        |
| Programadores:                                                         |
|              David Manuel Costa Gameiro          N:20281               |
|              Filipe Carvalho Mostardinha         N:22085               |
|                                                                        |
| Nome Ficheiro: InitPic.c                                               |
|                                                                        |
|                            SOURCE FILE                                 |
+=======================================================================*/


#include "pic.h"
#include "can_msg.h"


void lowPriorityISR(void);

// Quando ocorre um interrupt de baixa prioridade o programa "salta" para esta 						//linha do programa, cabe a linha de codigo goto CanTimerIsr reencaminhar para a
// rotina que se deseja executar como rotina de baixa prioridade.
#pragma code LowIsrVector = 0x018
void LowIsrVector(void)
{
_asm
	goto lowPriorityISR		        //salta para rotina de interrupt nao prioritario (baixa prio.)
_endasm
}
#pragma code


void initPic(void)
{
    /*------------------------------------------------------------------+
    |                    Definicoes dos TRIS do PIC                     |
    +------------------------------------------------------------------*/
    TRISA = 0;
    TRISB = 0;
    TRISC = 0;

    /*------------------------------------------------------------------+
    |                    Configurao do porto RA                       |
    +------------------------------------------------------------------*/

	ADCON1=0b00000110;      // All RA pins are digital

    /*------------------------------------------------------------------+
    |          			    Definicoes da USART             		    |
    +------------------------------------------------------------------*/

    initCan();

    /*------------------------------------------------------------------+
    |          			 Definies dos Interrupts             		    |
    +------------------------------------------------------------------*/

    // Activacao global das interrupcoes
	RCONbits.IPEN=1;		// Interrupt priority enable
	INTCONbits.GIEH=1;		// Enable high priority interrupts
	INTCONbits.GIEL=1;      // Enable low priority interrupts
}



// ****************************************************************************
// RSI de baixa prioridade
//
#pragma interrupt lowPriorityISR
void lowPriorityISR(void)
{
    // Recepo de uma mensagem
    if (PIR3bits.RXB1IF || PIR3bits.RXB0IF)  {

        // Leitura da mensagem recebida
        receiveCanMessage();
        // Envio de mensagens com a informao sensorial
        sendCanMessage();
    }
}
