#ifndef _SERVO_H
#define _SERVO_H

#include "global.h"

// Limiar de deciso para deteco do impulso de corrente acima
// do valor mnimo:
#define VPOT_IMPULSE_LIMIAR	60		// 60/1023*5.0 = 0.29V < 0.5V

#define DUTY_MIN	880  //(((unsigned int) 256-KT0_MAX)*T0_PRES/F_CPU)
#define DUTY_MAX	1900 //(((unsigned int) 256-KT0_MIN)*T0_PRES/F_CPU)

// O Timer 0  utilizado para definir o duty-cycle do PWM para o servo
#define SERVO_RANGE	90              // Gama de funcionamento do servo para cada lado (graus)
#define SERVO_RES   90              // Quantidade de posies possveis: para 72 -> Resoluo=2.5 (2*RANGE/RES)

// Pinos de interface do PIC
#define SERVO1_PIN	PORTBbits.RB4   // Saida de PWM para o servomotor (perodo de 20ms)
#define SERVO2_PIN	PORTBbits.RB5   // Saida de PWM para o servomotor (perodo de 20ms)
#define SERVO3_PIN	PORTBbits.RB6   // Saida de PWM para o servomotor (perodo de 20ms)

typedef struct {
    byte vpotMin;
    byte vpotImp;
} struct_adcAnalog;
extern struct_adcAnalog adcServo[N_SERVOS];

typedef struct  {
    byte pwm;
    signed int angle;
    signed int error_prev;
} struct_pwmServo;
extern struct_pwmServo pwmServo[N_SERVOS];

#define ANGLE_FACTOR    100

// Dados do controlador
// extern float controlRequested;

extern void initServoData(void);

extern void transferServoSensors(void);

extern void controller(void);

/*
// Inicializao do PIC e do controlador
extern void initController(signed int pos0);

// Preparao para comeo de execuo do controlador
// Indispensvel para evitar violaes de deadline fantasmas!
//
extern void controllerReady(void);

extern unsigned char controller(signed int posReference);

extern unsigned char deadlineSucess(void);
*/
#endif
