#ifndef _DATA__H
#define _DATA__H

#include "global.h"

// Massas dos elos em decagramas
#define M1 45
#define M2 45

// Dimenses dos elos mm
#define L1 95
#define L2 95

// Dimenses ao centro de massa de cada elo em mm
#define R1 47
#define R2 47

// Macros que convertem a posio das juntas em ngulos absolutos, e vice-versa
#define SERVO2THETA_DEG(pos,srv)   ((((signed int) pos-servo_offset[srv])*servo_signal[srv]*10)/(signed int) Nrel[srv])
#define CORRECT_SPEED(vel,srv)     (vel*(double) Nrel[srv]/10.0)

// Relao de transmisso das correias (*10)
#define NREL    {26, 26, 26}
extern const unsigned char Nrel[N_SERVOS];

// Offset das posies dos servos
#define SERVO_OFFSET   {0, 0, 70}
extern const signed char servo_offset[N_SERVOS];

// Diferena de sinal entre as posies dos servos e do ngulo de trabalho
#define SERVO_SIGNAL  {-1, -1, -1}
extern const signed char servo_signal[N_SERVOS];

// Lookup table com os valores do seno
extern const signed char sino_table[91];

#endif
