#include "mymaths.h"
#include "data.h"

unsigned int abs(signed int val)
{
    if (val<0)  val = ~val+1;
    return val;
}

// Ordem mnimo dos polinmios de McLawryn para o clculo das funes trigonomtricas
#define TRIG_ORDER 10

signed char seno(signed int alpha)
{
    signed int res;

    // Normalizao do ngulo entre -180 e +180 graus
    alpha=alpha%360;
    if (alpha>180)          alpha-=360;
    else if (alpha<-180)    alpha+=360;

    // Condies de equivalncia (alpha=[-90,+90])
    if (alpha>90)       alpha= 180-alpha;
    else if (alpha<-90) alpha=-180-alpha;

    // Mdulo do resultado
    res=sino_table[abs(alpha)];

    // Correco do resultado
    if (alpha<0)  res*=-1;

    return res;
}

signed char coseno(signed int alpha)
{
    return seno(90-alpha);
}
